# include <QtGui>

# include "tabelle.h"

tabelleWindow::tabelleWindow(QWidget *parent): QDialog(parent)
{
	setupUi(this);

	connect(saveButton, SIGNAL(clicked()), this, SLOT(speichern()));
	connect(reloadButton, SIGNAL(clicked()), this, SLOT(neuladen()));
	connect(tabelleWidget, SIGNAL(itemChanged(QTableWidgetItem *)), this, SLOT(aenderung(QTableWidgetItem *)));

}

void tabelleWindow::neuladen()
{
	int s=-1;
	int row=0;
	int column=0;
	int pos1,pos2,lastpos;
	QString line;
	QString eintrag;

	QString verzeichnis=QCoreApplication::applicationDirPath();
	verzeichnis.append("/tabellendaten.txt");

	QFile datei(verzeichnis);
	if (datei.open(QIODevice::ReadOnly | QIODevice::Text))
		{
		QApplication::setOverrideCursor(Qt::WaitCursor);
		tabelleWidget->clear();
		tabelleWidget->setRowCount(0);
		tabelleWidget->setColumnCount(0);

		QTextStream in(&datei);
		while(!in.atEnd())
			{
			line = in.readLine();
			tabelleWidget->insertRow(row);

			column=0;
			pos1=0;
			lastpos=0;
			while(pos1!=-1)
				{
				pos1=line.indexOf("\"",lastpos);
				lastpos=pos1+1;
				pos2=line.indexOf("\"",lastpos);
				lastpos=pos2+1;
				if(pos1!=-1)
					{
					if(s<column)
						{
						tabelleWidget->insertColumn(column);
						s=column;
						}
					eintrag=line.mid((pos1+1),(pos2-pos1-1));
					QTableWidgetItem *newItem = new QTableWidgetItem;
					newItem->setText(eintrag);

				// Für das Design der Zellen
					// newItem->setTextAlignment(Qt::AlignCenter);
					// newItem->setBackground(QColor(0, 0, 255, 255));
					// newItem->setForeground(QColor(255,255,255,255));
					// newItem->setFont(QFont("Arial", 12));

					if(row==0)
						{
						tabelleWidget->setHorizontalHeaderItem(column,newItem);
						}
					else	{
						tabelleWidget->setItem(row-1, column, newItem);
						}
					column++;
					}
				}
			row++;
			}
		tabelleWidget->removeRow(row-1);
		}
	datei.close();

	QApplication::restoreOverrideCursor();
	saveButton->setEnabled(false);
}


void tabelleWindow::speichern()
{
	QString inhalt;
	int z,i;

	QString verzeichnis=QCoreApplication::applicationDirPath();
	verzeichnis.append("/tabellendaten.txt");

	QFile datei(verzeichnis);
	if (datei.open(QFile::WriteOnly | QFile::Truncate))
		{
		QTextStream out(&datei);

		QApplication::setOverrideCursor(Qt::WaitCursor);

		for(i=0;i<tabelleWidget->columnCount();i++)
			{
			if(tabelleWidget->horizontalHeaderItem(i)!=0)
			    {
			    inhalt = tabelleWidget->horizontalHeaderItem(i)->text();
			    if(i==tabelleWidget->columnCount()-1)
				{
				out << "\"" << inhalt << "\"";
				}
			   else {
				out << "\"" << inhalt << "\" ";
				}
			   }
			}
		out << endl;

		for(z=0; z<tabelleWidget->rowCount(); z++)
			{
			for(i=0; i<tabelleWidget->columnCount(); i++)
				{
				if(tabelleWidget->item(z,i)!=0)
					{
					inhalt = tabelleWidget->item(z,i)->text();

					if(!inhalt.isEmpty())
						{
						if(i==tabelleWidget->columnCount()-1)
							{
							out << "\"" << inhalt << "\"";
							}
						else	{
							out << "\"" << inhalt << "\" ";
							}
						}
					}
				}
			out << endl;
			}
		}
		QApplication::restoreOverrideCursor();
	datei.close();

	saveButton->setEnabled(false);
}


void tabelleWindow::aenderung(QTableWidgetItem *)
{
	saveButton->setEnabled(true);
}

